﻿using System;

namespace SessionHunter.Business.Exceptions
{
    /// <summary>
    /// Thrown when there are logic errors in the user interface setup
    /// </summary>
    [Serializable]
    public class UserInterfaceException : ApplicationException
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="UserInterfaceException"/> class.
        /// </summary>
        public UserInterfaceException() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="UserInterfaceException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public UserInterfaceException(string message) : base(message) { }
        /// <summary>
        /// Initializes a new instance of the <see cref="UserInterfaceException"/> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="inner">The inner.</param>
        public UserInterfaceException(string message, Exception inner) : base(message, inner) { }
        /// <summary>
        /// Initializes a new instance of the <see cref="UserInterfaceException"/> class.
        /// </summary>
        /// <param name="info">The object that holds the serialized object data.</param>
        /// <param name="context">The contextual information about the source or destination.</param>
        protected UserInterfaceException(
          System.Runtime.Serialization.SerializationInfo info,
          System.Runtime.Serialization.StreamingContext context)
            : base(info, context) { }
    }
}
