﻿using System;

namespace SessionHunter.Business.SessionReading
{
    /// <summary>
    /// Raised whenever a specific number of sessions are processed
    /// </summary>
    public class SessionsProcessedArgs : EventArgs
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SessionsProcessedArgs"/> class.
        /// </summary>
        /// <param name="sessionsProcessed">The sessions processed.</param>
        public SessionsProcessedArgs(int sessionsProcessed)
        {
            SessionsProcessed = sessionsProcessed;
        }

        /// <summary>
        /// Gets or sets the number of sessions processed.
        /// </summary>
        public int SessionsProcessed
        {
            get;
            set;
        }
    }
}
