﻿
namespace SessionHunter.Messages
{
    /// <summary>
    /// Used to send a message to turn the busy indicator on or off
    /// </summary>
    public class BusyIndicatorMessage
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BusyIndicatorMessage"/> class.
        /// </summary>
        /// <param name="isBusy">if set to <c>true</c> [is busy].</param>
        /// <param name="message">The optional message to display.</param>
        public BusyIndicatorMessage(bool isBusy, string message = null)
        {
            IsBusy = isBusy;
            Message = message;
        }

        /// <summary>
        /// Gets or sets a value indicating whether to turn the busy indicator on or off
        /// </summary>        
        public bool IsBusy
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the message to display.
        /// </summary>
        /// <value>
        /// The message.
        /// </value>
        public string Message
        {
            get;
            set;
        }
    }
}
