﻿
namespace SessionHunter.Messages
{
    /// <summary>
    /// Used to send messages to the ChangeDatabaseConnectionView
    /// </summary>
    public class ChangeDatabaseConnectionMessage : MessageClassBase<ChangeDatabaseConnectionMessage.MessageAction>
    {

        /// <summary>
        /// Initializes a new instance of the <see cref="ChangeDatabaseConnectionMessage"/> class.
        /// </summary>
        /// <param name="message">The message we want to send to the view.</param>
        public ChangeDatabaseConnectionMessage(ChangeDatabaseConnectionMessage.MessageAction message)
            : base(message) { }

        /// <summary>
        /// Different actions the view can react to
        /// </summary>
        public enum MessageAction
        {
            /// <summary>
            /// Closes the dialog to change the connection string
            /// </summary>
            CloseChangeDatabaseConnectionDialog
        }
    }
}
