﻿
namespace SessionHunter.Messages
{
    /// <summary>
    /// If we need to send messages to the MainWindow
    /// </summary>
    public class MainWindowMessage : MessageClassBase<MainWindowMessage.MessageAction>
    {

        /// <summary>
        /// Initializes a new instance of the <see cref="MainWindowMessage"/> class.
        /// </summary>
        /// <param name="message">The message we want to send to the view.</param>
        public MainWindowMessage(MainWindowMessage.MessageAction message)
            : base(message) { }

        /// <summary>
        /// Different actions the view can react to
        /// </summary>
        public enum MessageAction
        {
            /// <summary>
            /// Makes the references button blink
            /// </summary>
            References_Attention,
            /// <summary>
            /// Clear out the session list because something has changed that requires a manual refresh
            /// </summary>
            Clear_SessionList
        }
    }
}
