﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SessionHunter.Messages
{
    /// <summary>
    /// A way to send messages to various views, but the message to be defined by an enum instead of a string
    /// </summary>
    /// <typeparam name="MessageActionType">The enum with the messages.</typeparam>
    public abstract class MessageClassBase<MessageActionType>
    {

        /// <summary>
        /// Initializes a new instance of the <see cref="MessageClassBase&lt;MessageActionType&gt;"/> class.
        /// </summary>
        /// <param name="message">Which message we want to send to the view.</param>
        protected MessageClassBase(MessageActionType message)
        {
            Message = message;
        }

        /// <summary>
        /// The type of message sent and received
        /// </summary>
        public MessageActionType Message;
    }
}
